#coding=utf-8

from sklearn.decomposition import NMF
import scipy.io as scio
import numpy as np
#from  diffusionmap import dmap
from sklearn import svm
from sklearn.externals import joblib
from sklearn.cross_validation import train_test_split
from sklearn.grid_search import GridSearchCV
from sklearn.metrics import classification_report
from sklearn.svm import SVC
from sklearn import preprocessing

data1=scio.loadmat('normalfeature.mat')
data2=scio.loadmat('abnormalfeature.mat')
normal=data1['normalfeature']
murmur=data2['abnormalfeature']


tr1=2495
tr2=630
fdim=int(murmur.size/tr2)

normal=normal[0:tr1,0:fdim]
murmur=murmur[0:tr2,0:fdim]

data=np.concatenate((normal[0:tr1,0:fdim],murmur[0:tr2,0:fdim]))
target=np.concatenate((np.ones((tr1,)),np.zeros((tr2,))))

min_max_scaler = preprocessing.MinMaxScaler()
b=min_max_scaler.fit_transform(data)

#clf=svm.SVC(kernel='rbf',probability=True, gamma=0.01,C=100,class_weight={0:2})
clf=svm.SVC(kernel='rbf',probability=True, gamma=0.01,C=100)
clf.fit(b,target)

tt=clf.predict(b)
print(sum(tt[0:tr1]))
print(sum(tt[tr1:tr1+tr2]))
print(clf.support_vectors_.shape)



joblib.dump(clf,"train_model.m")
joblib.dump(min_max_scaler,"scale_data.m")
